connect 'jdbc:derby:cheesedb;create=true';

create table room_t (
	roomid		int not null generated always as identity,
	name		varchar(255),

	edesc		long varchar,
	notes		long varchar,

	terrain		char(1),

-- comma sep'd list of overlay_foo types
	overlays	varchar(255),

-- these will be roomids, or:
--   0 if no exit there
--  -1 if not explored
--  -2 if dt
--  -3 if random
	exit_e		int not null,
	door_e		varchar(255),

	exit_w		int not null,
	door_w		varchar(255),

	exit_n		int not null,
	door_n		varchar(255),

	exit_s		int not null,
	door_s		varchar(255),

	exit_u		int not null,
	door_u		varchar(255),

	exit_d		int not null,
	door_d		varchar(255),

	x		int,
	y		int,
	z		int,

	mtime		bigint,
	userid		varchar(255),

	primary key	(roomid)
);

create index room_name_i on room_t (name);
create index room_x_i on room_t (x);
create index room_y_i on room_t (y);
create index room_z_i on room_t (z);
create index room_mtime_i on room_t (mtime);

create table user_t
(
	userid		varchar(255) not null,
	password	varchar(255),

	x		int,
	y		int,
	z		int,

-- If this is zero we are lost
	roomid		int,

	hit_curr	int,
	hit_max		int,
	move_curr	int,
	move_max	int,
	mana_curr	int,
	mana_max	int,

-- Permissions, each char is a +something, 
-- A is all/admin permission
-- s is save
-- u is usermanager
	permissions	varchar(255),

-- Pref flags stored in the server
	preferences	varchar(255),

-- Online
	online		smallint,

-- A vector of future movement, roomid,x,y,z-next
	future		long varchar,

	primary key (userid)
);

-- the default user
insert into user_t (userid, password, permissions,x,y,z) values ('default','','A',10000,10000,10000);

-- a small options table
create table option_t
(
	optionid	varchar(30),
	value		varchar(255)
);

-- db schema version so that upgrade progs can detect the schema and alter it if needed
insert into option_t (optionid, value) values ('dbversion', '4');

exit;
